var queueStringArray = Array();
var queueCodeArray = Array();
var inQueueStringArray = Array();
var inQueueCodeArray = Array();
var intervalTime = 30; //ms
var ASCLLLength = 16;

var config = {
	"-1": {voltage: -10, current: -0.3773, receive:{"-2": 0, "-1": -0.0972, "0": -0.1281, "1": -0.1404}},
	"0": {voltage: -20, current: -1.948, receive:{"-2": 0, "-1": -0.2432, "0": -0.3323, "1": -0.3723}},
	"1": {voltage: -30, current: -4.277, receive:{"-2": 0, "-1": -0.33517, "0": -0.4845, "1": -0.5591}},
}

$(document).ready(function(){
	console.log('ready');
	sendCode(-1);
	sendInCode(-2);

	//interval
	setInterval(function(){
		//display queue
		$("#display-sendOut-string").text(queueStringArray.join(""));
		var tempCodeJoin = Array();
		for(var i=0;i<queueCodeArray.length;i++){
			tempCodeJoin.push(queueCodeArray[i].join(""));
		}
		$("#display-sendOut-code").text(tempCodeJoin.join(""));

		$("#display-sendIn-string").text(inQueueStringArray.join(""));
		var tempCodeJoin = Array();
		for(var i=0;i<inQueueCodeArray.length;i++){
			tempCodeJoin.push(inQueueCodeArray[i].join(""));
		}
		$("#display-sendIn-code").text(tempCodeJoin.join(""));

		//handel queue
		if(queueCodeArray[0] && queueCodeArray[0].length > 0){
			sendCode(queueCodeArray[0][0]);
			queueCodeArray[0].shift();
			if(queueCodeArray[0].length == 0){
				queueCodeArray.shift();
				queueStringArray.shift();
			}
		}else{
			sendCode(-1);
		}

		if(inQueueCodeArray[0] && inQueueCodeArray[0].length > 0){
			sendInCode(inQueueCodeArray[0][0]);
			inQueueCodeArray[0].shift();
			if(inQueueCodeArray[0].length == 0){
				inQueueCodeArray.shift();
				inQueueStringArray.shift();
			}
		}else{
			sendInCode(-2);
		}

		//refresh device panel
		var current = parseFloat($("#device-darkcurrent").text())+parseFloat($("#device-photocurrent").text());
		$("#device-current").text(current.toFixed(5));
		var width = current*-1/5*100;
		$("#device-emission").css("width", width.toFixed(2)+'%');

		//decode message
		$("#decoded-code").append(decodeCode());
		//show string
		var codes = $("#decoded-code").text();
		var stringArray = Array();
		for(i=0;i<(codes.length/ASCLLLength);i++){
			code = codes.substring(i*ASCLLLength,(i+1)*ASCLLLength);
			if(code.length == ASCLLLength){
				stringArray.push(String.fromCharCode(parseInt(code,2)));
			}
		}
		$("#decoded-message").text(stringArray.join(""));
		
	}, intervalTime);
});

//sendOut
function sendOut(){
	var sendOut = $("#sendOut").val();
	if(sendOut.length >= 0){
		//add to queue
		// sendOut = "<{"+sendOut+"}>";
		sendOutCharArray = sendOut.split('');
		for(var i=0;i<sendOutCharArray.length;i++){
			var binaryCode = binary(sendOutCharArray[i].charCodeAt(), ASCLLLength);
			queueStringArray.push(sendOutCharArray[i]);
			queueCodeArray.push(binaryCode.split(''));
		}
	}

	return false;
}

function sendIn(){
	var sendIn = $("#sendIn").val();
	// sendIn = ">";
	// sendIn = "<{"+sendIn+"}>";
	if(sendIn.length >= 0){
		// sendInCode(-1);//standby
		// clearReceive();
		//add to queue
		sendInCharArray = sendIn.split('');
		for(var i=0;i<sendInCharArray.length;i++){
			var binaryCode = binary(sendInCharArray[i].charCodeAt(), ASCLLLength);
			inQueueStringArray.push(sendInCharArray[i]);
			inQueueCodeArray.push(binaryCode.split(''));
		}
	}

	return false;
}

//control the voltage

function sendCode(code){
	$("#device-voltage").text(config[code].voltage);
	$("#device-darkcurrent").text(config[code].current);
}

function sendInCode(code){
	$("#device-photocurrent").text(config[getCurrentEmissionStatus()].receive[code]);
}

function decodeCode(){
	var emissionStatus = getCurrentEmissionStatus();
	// console.log(parseFloat($("#device-current").text()));
	var calPhotocurrent = parseFloat($("#device-current").text()) - config[emissionStatus].current;
	var receive = config[emissionStatus].receive;
	for(i=0;i<2;i++){
		// console.log(calPhotocurrent.toFixed(5));
		if(receive[i] == calPhotocurrent.toFixed(5)){
			return i;
		}
	}
}

function getCurrentEmissionStatus(){
	currentVoltage = parseFloat($("#device-voltage").text());
	if(currentVoltage == config[-1].voltage){
		emissionStatus = -1;
	}else if(currentVoltage == config[0].voltage){
		emissionStatus = 0;
	}else if(currentVoltage == config[1].voltage){
		emissionStatus = 1;
	}
	return emissionStatus;
}

function clearReceive(){
	$("#decoded-code").text("");
}

function binary(num, Bits) {
var resArry = [];
var xresArry = [];
i = 0;
for (; num > 0;) {
resArry.push(num % 2);
num = parseInt(num / 2);
i++;
}

for (j = i - 1; j >= 0; j--) {
xresArry.push(resArry[j]);
}

if (Bits < xresArry.length) {
console.log("too short");
}

if (Bits) {
for (r = xresArry.length; r < Bits; r++) {
xresArry.unshift("0");
}
}
return xresArry.join().replace(/,/g, "");
}